# DevSecOps 2022



## Цель обучения

Освоить современные практики непрерывной интеграции и доставки нового кода (Continuous Integration / Continuous Delivery, CI/CD) на примере технологий GitLab/GitFlow и Docker. Участники разберутся с принципами CI/CD, научатся создавать пайплайны на примере Gitlab CI, освоят методы и инструменты контейнеризации на примере Docker, научатся строить цепочку поставки, включающую все основные стадии - сборка, тестирование, упаковка, сканирование.

## Темы

В рамках обучения мы рассматриваем следующие темы:

- [ ] Введение в DevOps/DevSecOps
- [ ] Инструменты совместной работы
- [ ] Технологии контейнеризации
- [ ] Обеспечение безопасности контейнеров
- [ ] Автоматизация цепочки поставки
- [ ] Безопасность рабочей нагрузки
- [ ] Технологии оркестрации (самостоятельная работа)

## Требования к участникам
- [ ] Участники должны не бояться работать с командной строкой.
- [ ] Знать основы Linux (базовое администрирование). 
- [ ] Базовые навыки программирование.
- [ ] Базовые знания компьютерных сетей. 
- [ ] Базовые навыки работы с git.

Инструменты совместной работы (git) является одной из тем, которые мы рассматриваем, но предполагается, что вы знаете основы работы с git.
Некоторые базовые вещи [разбираются в этом видео](https://youtu.be/U0yPHH72l1k) 
Пожалуйста, ознакомьтесь с ним заранее, если у вас нет опыта работы с git.

## (ВАЖНО) Необходимые действия до начала обучения 

1. Вам необходимо зарегистрироваться на платформе [GitLab (DevSecOps platform)](https://gitlab.com/)
    - [ ] Все задания, требующие использования репозитория и запуска CI/CD пайплайнов, будет делать на этой платформе.

2. Вам необходимо зарегистрироваться на  [Docker Hub](https://hub.docker.com/)
    - [ ] Сюда мы будет загружать полученные образы контейнеров.

3. Вам необходимо подготовить компьютер, установив на него [необходимое ПО](https://git.miem.hse.ru/vbashun/devsecops2022/-/blob/master/README.md#%D0%BD%D0%B5%D0%BE%D0%B1%D1%85%D0%BE%D0%B4%D0%B8%D0%BC%D0%BE%D0%B5-%D0%BF%D0%BE)
    - [ ] Без его установки, вы не сможете выполнять задания.

## Необходимое ПО 

Для выполнения практических заданий вам понадобится:

- [ ] Клиент git

    - Установка git client
        - https://git-scm.com/book/ru/v2/%D0%92%D0%B2%D0%B5%D0%B4%D0%B5%D0%BD%D0%B8%D0%B5-%D0%A3%D1%81%D1%82%D0%B0%D0%BD%D0%BE%D0%B2%D0%BA%D0%B0-Git 
        - https://git-scm.com/book/en/v2/Getting-Started-Installing-Git 
        - https://git-scm.com/download/win 

    - Много полезной информации по работе с git
        - https://git-scm.com/book/ru/v2/

- [ ] Docker (или другое CRI-совместимое решение). 

Мы рекомендуем использовать docker под ОС Linux (если у вас другая ОС, можно развернуть ее, например, в virtual box).

    - Документация по установке docker:
        - https://docs.docker.com/engine/install/

    - Если вы будете работать с docker под Windows
        - https://docs.docker.com/desktop/install/windows-install/ 
        - https://learn.microsoft.com/ru-ru/virtualization/windowscontainers/quick-start/set-up-environment?tabs=Windows-Server


### Для самостоятельного изучения темы оркестраторы

Так же для выполнения самостоятельной работы по оркестраторам вам понадобится (***вы можете сделать это позднее**, материалы для самостоятельного изучения будут доступны и после завершения обучения)

- Minikube и одним из драйверов на выбор (Docker, Hyperkit, Hyper-V, KVM, Parallels, Podman, VirtualBox, or VMware Fusion/Workstation). Рекомендуется VirtualBox или VMware
    - https://minikube.sigs.k8s.io/docs/start/ 

